SUBROUTINE RESGKL_MAIN(ini,method,LS,ACCURACY)
  use my_data
  use omp_lib
  IMPLICIT NONE
  
  integer LS
  REAL IDEN(nsv,nsv),OERR
  REAL MIN_ERR,TMP_ERR,TAVE,CONST,ZERO,ONE,TWO,TEN,ERR,SNRM2,TMAX
  DOUBLE PRECISION MINT,STARTT,TMPT
  PARAMETER (ZERO = 0.0E+0,ONE = 1.0E+0,TWO = 2.0E+0,TEN = 10.0E+0)
  INTEGER ISEED(4),ini,method
  INTEGER COU,ACCURACY,I,ITR
  REAL SDOT
  EXTERNAL SDOT
  
  ISEED( 1 ) = ini
  ISEED( 2 ) = 402+ini*13
  ISEED( 3 ) = 2+ini*3
  ISEED( 4 ) = 111+ini*7
  print *, "MODE = ",MODE
  WRITE (*,*) "M N K L"
  WRITE (*,*) M,N,ncv,nsv
  
  CONST = TEN**(ZERO - accuracy)
  if(min(M,N)<ncv) then
     print *,"! ERR K must be smaller than",min(M,N)
  end if
  
  s0 = ZERO
  opcount = 0
  CALL SLARNV(1,ISEED,N,VPLUS)
  VPLUS = VPLUS / SNRM2(N,VPLUS,1)
  
  STARTT = omp_get_wtime()
  WRITE(*,*) 
  BK = ZERO
  UK = ZERO
  VK = ZERO
  MIN_ERR = -ONE
  COU = 0
  ITR = 0
  I = 0
  DO WHILE (COU < 1500000)
     
     CALL RESGKL(I,LS,METHOD)
     
     TMP_ERR = MAXVAL(ABS(BK(1:nsv,nsv+1)))
     
     ITR = ITR+1
     TMPT = omp_get_wtime()
     IF ( (TMP_ERR < MIN_ERR) .OR. (MIN_ERR .EQ. -ONE) ) THEN
        MIN_ERR = TMP_ERR
        MINT = TMPT
        COU = -1
     END IF
     
     WRITE(*,*) METHOD,ITR,(TMPT-STARTT),TMP_ERR
     IF(TMP_ERR .LE. CONST) exit
     COU = COU + 1
  END DO
  
  TAVE = ERR(TMAX)
  
  IDEN = ZERO
  DO I = 1,nsv
     IDEN(I,I) = -ONE
  END DO
  CALL SSYRK('U','T',nsv,N,ONE,VK,N,ONE,IDEN,nsv)
  OERR = ZERO
!$OMP PARALLEL DO REDUCTION( +:OERR )
  DO I = 2, nsv
     OERR = OERR + SDOT(I-1,IDEN(1,I),1,IDEN(1,I),1)
  ENDDO
!$OMP END PARALLEL DO
  OERR = TWO*OERR
  DO I = 1, nsv
     OERR = OERR + IDEN(I,I)**2
  ENDDO
  WRITE(*,*) "OERR VK",SQRT(OERR)

  IDEN = ZERO
  DO I = 1, nsv
     IDEN(I,I) = -ONE
  END DO
  CALL SSYRK('U','T',nsv,M,ONE,UK,M,ONE,IDEN,nsv)
  OERR = ZERO
!$OMP PARALLEL DO REDUCTION( +:OERR )
  DO I = 2, nsv
     OERR = OERR + SDOT(I-1,IDEN(1,I),1,IDEN(1,I),1)
  ENDDO
!$OMP END PARALLEL DO
  OERR = TWO*OERR
  DO I = 1, nsv
     OERR = OERR + IDEN(I,I)**2
  ENDDO
  WRITE(*,*) "OERR UK",SQRT(OERR)

  WRITE(*,*) "TIME", METHOD,ITR,(TMPT-STARTT),TMP_ERR,"AVE",TAVE,"MAX",TMAX
  WRITE(*,*) "MATRIX VECTOR COMPUTATION (sec)",s0
  WRITE(*,*) "Total number of OP*x operations  :",opcount
  
  DO I = 1,nsv
     WRITE (*,*) "SingularValue",I, BK(I,I)
  END DO

END SUBROUTINE RESGKL_MAIN
